diff -Nur --exclude=.svn src/config.h.in soci/config.h.in
--- src/config.h.in	1970-01-01 01:00:00.000000000 +0100
+++ soci/config.h.in	2009-04-19 23:57:01.000000000 +0200
@@ -0,0 +1,165 @@
+/* soci/config.h.in.  Generated from configure.ac by autoheader.  */
+
+/* Define to 1 if translation of program messages to the user's native
+   language is requested. */
+#undef ENABLE_NLS
+
+/* define if the Boost library is available */
+#undef HAVE_BOOST
+
+/* define if the Boost::Date_Time library is available */
+#undef HAVE_BOOST_DATE_TIME
+
+/* define if the Boost::FILESYSTEM library is available */
+#undef HAVE_BOOST_FILESYSTEM
+
+/* define if the Boost::IOStreams library is available */
+#undef HAVE_BOOST_IOSTREAMS
+
+/* define if the Boost::PROGRAM_OPTIONS library is available */
+#undef HAVE_BOOST_PROGRAM_OPTIONS
+
+/* define if the Boost::Regex library is available */
+#undef HAVE_BOOST_REGEX
+
+/* define if the Boost::Serialization library is available */
+#undef HAVE_BOOST_SERIALIZATION
+
+/* define if the Boost::Signals library is available */
+#undef HAVE_BOOST_SIGNALS
+
+/* define if the Boost::THREAD library is available */
+#undef HAVE_BOOST_THREAD
+
+/* define if the Boost::Unit_test_framework library is available */
+#undef HAVE_BOOST_UNIT_TEST_FRAMEWORK
+
+/* Define to 1 if you have the <cmath> header file. */
+#undef HAVE_CMATH
+
+/* Define if the GNU dcgettext() function is already present or preinstalled.
+   */
+#undef HAVE_DCGETTEXT
+
+/* Define to 1 if you have the <deque> header file. */
+#undef HAVE_DEQUE
+
+/* Define to 1 if you have the <dlfcn.h> header file. */
+#undef HAVE_DLFCN_H
+
+/* Define to 1 if FireBird libraries are available */
+#undef HAVE_FIREBIRD
+
+/* Define to 1 if you have the <fstream> header file. */
+#undef HAVE_FSTREAM
+
+/* Define if the GNU gettext() function is already present or preinstalled. */
+#undef HAVE_GETTEXT
+
+/* Define if you have the iconv() function. */
+#undef HAVE_ICONV
+
+/* Define to 1 if you have the <inttypes.h> header file. */
+#undef HAVE_INTTYPES_H
+
+/* Define to 1 if you have the <iomanip> header file. */
+#undef HAVE_IOMANIP
+
+/* Define to 1 if you have the <iostream> header file. */
+#undef HAVE_IOSTREAM
+
+/* Define to 1 if you have the <limits> header file. */
+#undef HAVE_LIMITS
+
+/* Define to 1 if you have the <list> header file. */
+#undef HAVE_LIST
+
+/* Define to 1 if you have the <map> header file. */
+#undef HAVE_MAP
+
+/* Define to 1 if you have the <memory.h> header file. */
+#undef HAVE_MEMORY_H
+
+/* Define to 1 if MySQL libraries are available */
+#undef HAVE_MYSQL
+
+/* Define to 1 if ODBC library is available */
+#undef HAVE_ODBC
+
+/* Define to 1 if the Oracle OCI library is available */
+#undef HAVE_ORACLE
+
+/* Define to 1 if PostgreSQL libraries are available */
+#undef HAVE_POSTGRESQL
+
+/* Define to 1 if you have the <queue> header file. */
+#undef HAVE_QUEUE
+
+/* Define to 1 if you have the <set> header file. */
+#undef HAVE_SET
+
+/* Define to 1 if SQLite 3 library is available */
+#undef HAVE_SQLITE3
+
+/* Define to 1 if you have the <sstream> header file. */
+#undef HAVE_SSTREAM
+
+/* Define to 1 if you have the <stdexcept> header file. */
+#undef HAVE_STDEXCEPT
+
+/* Define to 1 if you have the <stdint.h> header file. */
+#undef HAVE_STDINT_H
+
+/* Define to 1 if you have the <stdlib.h> header file. */
+#undef HAVE_STDLIB_H
+
+/* Define to 1 if you have the <string> header file. */
+#undef HAVE_STRING
+
+/* Define to 1 if you have the <strings.h> header file. */
+#undef HAVE_STRINGS_H
+
+/* Define to 1 if you have the <string.h> header file. */
+#undef HAVE_STRING_H
+
+/* Define to 1 if you have the <sys/stat.h> header file. */
+#undef HAVE_SYS_STAT_H
+
+/* Define to 1 if you have the <sys/types.h> header file. */
+#undef HAVE_SYS_TYPES_H
+
+/* Define to 1 if you have the <unistd.h> header file. */
+#undef HAVE_UNISTD_H
+
+/* Define to 1 if you have the <vector> header file. */
+#undef HAVE_VECTOR
+
+/* Name of package */
+#undef PACKAGE
+
+/* Define to the address where bug reports for this package should be sent. */
+#undef PACKAGE_BUGREPORT
+
+/* Define to the full name of this package. */
+#undef PACKAGE_NAME
+
+/* Define to the full name and version of this package. */
+#undef PACKAGE_STRING
+
+/* Define to the one symbol short name of this package. */
+#undef PACKAGE_TARNAME
+
+/* Define to the version of this package. */
+#undef PACKAGE_VERSION
+
+/* Define if you want exceptions handling */
+#undef SOCI_EXCEPTIONS
+
+/* Define to 1 if you have the ANSI C header files. */
+#undef STDC_HEADERS
+
+/* Define to 1 if you can safely include both <sys/time.h> and <time.h>. */
+#undef TIME_WITH_SYS_TIME
+
+/* Version number of package */
+#undef VERSION
diff -Nur --exclude=.svn src/core/Makefile.am soci/core/Makefile.am
--- src/core/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/core/Makefile.am	2009-04-19 02:43:40.000000000 +0200
@@ -1,83 +1,29 @@
-# $Id: Makefile.am,v 1.14 2008/05/20 21:24:11 msobczak Exp $
-# 
-# Copyright (C) 2006, Mateusz Loskot
-#
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-AM_CXXFLAGS = -fPIC $(BOOST_CPPFLAGS)
-
-SUBDIRS = test
-
-lib_LTLIBRARIES	= lib@SOCI_CORE_LIBRARY_NAME@.la
-
-lib@SOCI_CORE_LIBRARY_NAME@_la_LDFLAGS = \
-	-release @LIBTOOL_RELEASE@ -no-undefined @LD_LIB@
-
-lib@SOCI_CORE_LIBRARY_NAME@_la_SOURCES = \
-	backend-loader.cpp \
-	blob.cpp \
-	connection-pool.cpp \
-	error.cpp \
-	into-type.cpp \
-	once-temp-type.cpp \
-	prepare-temp-type.cpp \
-	procedure.cpp \
-	ref-counted-prepare-info.cpp \
-	ref-counted-statement.cpp \
-	row.cpp \
-	rowid.cpp \
-	session.cpp \
-	soci-simple.cpp \
-	statement.cpp \
-	transaction.cpp \
-	use-type.cpp \
-	values.cpp
-
-socidir = $(includedir)/soci
-
-soci_HEADERS = \
-	backend-loader.h \
-	blob.h \
-	blob-exchange.h \
-	boost-gregorian-date.h \
-	boost-fusion.h \
-	boost-optional.h \
-	boost-tuple.h \
-	connection-pool.h \
-	error.h \
-	exchange-traits.h \
-	into.h \
-	into-type.h \
-	once-temp-type.h \
-	prepare-temp-type.h \
-	procedure.h \
-	ref-counted-prepare-info.h \
-	ref-counted-statement.h \
-	row.h \
-	row-exchange.h \
-	rowid.h \
-	rowid-exchange.h \
-	rowset.h \
-	session.h \
-	soci-backend.h \
-	soci-config.h \
-	soci-platform.h \
-	soci-simple.h \
-	soci.h \
-	statement.h \
-	transaction.h \
-	type-conversion.h \
-	type-conversion-traits.h \
-	type-holder.h \
-	type-ptr.h \
-	use.h \
-	use-type.h \
-	values.h \
-	values-exchange.h
-
-EXTRA_DIST = Makefile.basic
-
-MAINTAINERCLEANLOCAL = Makefile.in
-
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+## core sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
+
+MAINTAINERCLEANFILES = Makefile.in
+
+#EXTRA_DIST_FOR_SOCI_COMPATIBILITY = ._row.cpp ._soci-simple.cpp ._soci-simple.h ._values-exchange.h
+EXTRA_DIST_FOR_SOCI_COMPATIBILITY = Makefile.basic
+
+EXTRA_DIST = $(EXTRA_DIST_FOR_SOCI_COMPATIBILITY)
+
+SUBDIRS = . test
+
+lib_LTLIBRARIES= libsoci_core.la
+
+libsoci_core_la_SOURCES= $(core_h_sources) $(core_cc_sources) 
+libsoci_core_la_CXXFLAGS =
+libsoci_core_la_LIBADD =
+libsoci_core_la_LDFLAGS = \
+	$(BOOST_LIBS) $(BOOST_DATE_TIME_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) \
+	-version-info $(GENERIC_LIBRARY_VERSION)
+
+pkginclude_HEADERS = $(core_h_sources)
+if SOCI_HEADERS_BURIED
+soci_include_dir = $(includedir)/soci/core
+else
+soci_include_dir = $(includedir)
+endif
+pkgincludedir = $(soci_include_dir)
diff -Nur --exclude=.svn src/core/sources.mk soci/core/sources.mk
--- src/core/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/core/sources.mk	2009-03-28 18:31:10.000000000 +0100
@@ -0,0 +1,58 @@
+core_h_sources = \
+        $(top_srcdir)/soci/core/backend-loader.h \
+        $(top_srcdir)/soci/core/blob.h \
+        $(top_srcdir)/soci/core/blob-exchange.h \
+        $(top_srcdir)/soci/core/boost-gregorian-date.h \
+        $(top_srcdir)/soci/core/boost-fusion.h \
+        $(top_srcdir)/soci/core/boost-optional.h \
+        $(top_srcdir)/soci/core/boost-tuple.h \
+        $(top_srcdir)/soci/core/connection-pool.h \
+        $(top_srcdir)/soci/core/error.h \
+        $(top_srcdir)/soci/core/exchange-traits.h \
+        $(top_srcdir)/soci/core/into.h \
+        $(top_srcdir)/soci/core/into-type.h \
+        $(top_srcdir)/soci/core/once-temp-type.h \
+        $(top_srcdir)/soci/core/prepare-temp-type.h \
+        $(top_srcdir)/soci/core/procedure.h \
+        $(top_srcdir)/soci/core/ref-counted-prepare-info.h \
+        $(top_srcdir)/soci/core/ref-counted-statement.h \
+        $(top_srcdir)/soci/core/row.h \
+        $(top_srcdir)/soci/core/row-exchange.h \
+        $(top_srcdir)/soci/core/rowid.h \
+        $(top_srcdir)/soci/core/rowid-exchange.h \
+        $(top_srcdir)/soci/core/rowset.h \
+        $(top_srcdir)/soci/core/session.h \
+        $(top_srcdir)/soci/core/soci-backend.h \
+        $(top_srcdir)/soci/core/soci-config.h \
+        $(top_srcdir)/soci/core/soci-platform.h \
+        $(top_srcdir)/soci/core/soci-simple.h \
+        $(top_srcdir)/soci/core/soci.h \
+        $(top_srcdir)/soci/core/statement.h \
+        $(top_srcdir)/soci/core/transaction.h \
+        $(top_srcdir)/soci/core/type-conversion.h \
+        $(top_srcdir)/soci/core/type-conversion-traits.h \
+        $(top_srcdir)/soci/core/type-holder.h \
+        $(top_srcdir)/soci/core/type-ptr.h \
+        $(top_srcdir)/soci/core/use.h \
+        $(top_srcdir)/soci/core/use-type.h \
+        $(top_srcdir)/soci/core/values.h \
+        $(top_srcdir)/soci/core/values-exchange.h
+core_cc_sources = \
+        $(top_srcdir)/soci/core/backend-loader.cpp \
+        $(top_srcdir)/soci/core/blob.cpp \
+        $(top_srcdir)/soci/core/connection-pool.cpp \
+        $(top_srcdir)/soci/core/error.cpp \
+        $(top_srcdir)/soci/core/into-type.cpp \
+        $(top_srcdir)/soci/core/once-temp-type.cpp \
+        $(top_srcdir)/soci/core/prepare-temp-type.cpp \
+        $(top_srcdir)/soci/core/procedure.cpp \
+        $(top_srcdir)/soci/core/ref-counted-prepare-info.cpp \
+        $(top_srcdir)/soci/core/ref-counted-statement.cpp \
+        $(top_srcdir)/soci/core/row.cpp \
+        $(top_srcdir)/soci/core/rowid.cpp \
+        $(top_srcdir)/soci/core/session.cpp \
+        $(top_srcdir)/soci/core/soci-simple.cpp \
+        $(top_srcdir)/soci/core/statement.cpp \
+        $(top_srcdir)/soci/core/transaction.cpp \
+        $(top_srcdir)/soci/core/use-type.cpp \
+        $(top_srcdir)/soci/core/values.cpp
diff -Nur --exclude=.svn src/core/test/common-tests.h soci/core/test/common-tests.h
--- src/core/test/common-tests.h	2009-04-19 22:58:52.000000000 +0200
+++ soci/core/test/common-tests.h	2009-04-19 18:03:56.000000000 +0200
@@ -8,14 +8,23 @@
 #ifndef SOCI_COMMON_TESTS_H_INCLUDED
 #define SOCI_COMMON_TESTS_H_INCLUDED
 
-#include "soci.h"
-#include "soci-config.h"
-
 // explicitly pull conversions for Boost's optional, tuple and fusion:
+#if defined(SOCI_HEADERS_BURIED)
+#       include <soci/core/soci.h>
+#       include <soci/core/soci-config.h>
+#       include <soci/core/boost-optional.h>
+#       include <soci/core/boost-tuple.h>
+#       include <soci/core/boost-gregorian-date.h>
+#else
+#	include <soci.h>
+#       include <soci-config.h>
+#       include <boost-optional.h>
+#       include <boost-tuple.h>
+#       include <boost-gregorian-date.h>
+#endif
+//
+
 #include <boost/version.hpp>
-#include <boost-optional.h>
-#include <boost-tuple.h>
-#include <boost-gregorian-date.h>
 #if defined(BOOST_VERSION) && BOOST_VERSION >= 103500
 #include <boost-fusion.h>
 #endif // BOOST_VERSION
diff -Nur --exclude=.svn src/core/test/Makefile.am soci/core/test/Makefile.am
--- src/core/test/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/core/test/Makefile.am	2009-04-09 00:53:13.000000000 +0200
@@ -1,17 +1,15 @@
-# $Id: Makefile.am,v 1.2 2007/06/23 01:51:22 mloskot Exp $
-# 
-# Copyright (C) 2006, Mateusz Loskot
-#
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-AM_CPPFLAGS = $(BOOST_CPPFLAGS)
+## core sub-directory
+include $(top_srcdir)/Makefile.common
+include $(srcdir)/sources.mk
 
-socidir = $(includedir)/soci
+MAINTAINERCLEANFILES = Makefile.in
 
-noinst_HEADERS = \
-	common-tests.h
+noinst_LTLIBRARIES= libsoci_core_test.la
 
-MAINTAINERCLEANLOCAL = Makefile.in
+libsoci_core_test_la_SOURCES= $(core_test_h_sources)
+libsoci_core_test_la_CXXFLAGS =
+libsoci_core_test_la_LIBADD =
+libsoci_core_test_la_LDFLAGS = -version-info $(GENERIC_LIBRARY_VERSION)
 
-maintainer-clean-local:
-	-test -z "$(MAINTAINERCLEANLOCAL)" || rm -rf $(MAINTAINERCLEANLOCAL)
+#nodist_pkginclude_HEADERS = $(core_test_h_sources)
+#pkgincludedir = $(includedir)/soci/core
diff -Nur --exclude=.svn src/core/test/sources.mk soci/core/test/sources.mk
--- src/core/test/sources.mk	1970-01-01 01:00:00.000000000 +0100
+++ soci/core/test/sources.mk	2009-04-09 00:50:02.000000000 +0200
@@ -0,0 +1,2 @@
+core_test_h_sources = $(top_srcdir)/soci/core/test/common-tests.h
+core_test_cc_sources =
diff -Nur --exclude=.svn src/Makefile.am soci/Makefile.am
--- src/Makefile.am	2009-04-19 22:58:52.000000000 +0200
+++ soci/Makefile.am	2009-03-28 18:38:52.000000000 +0100
@@ -1,10 +1,9 @@
-# $Id: Makefile.am,v 1.2 2006/11/29 08:38:36 mloskot Exp $
-# 
-# Author: Mateusz Loskot <mateusz@loskot.net>
-#
-SUBDIRS = \
-	core \
-	backends
+include $(top_srcdir)/Makefile.common
 
-EXTRA_DIST = 
+## Source directory
 
+MAINTAINERCLEANFILES = Makefile.in
+
+SUBDIRS = core backends
+
+EXTRA_DIST =
